summary.rollback.table <-
function(TheTree) {
	Matrixset <- convert2matrix(TheTree)
	x <- Matrixset$x
	y <- Matrixset$y
	probMAT <- Matrixset$probMAT
	utilityMAT <- Matrixset$utilityMAT
	effectivenessMAT <- Matrixset$effectivenessMAT
	typeMAT <- Matrixset$typeMAT
	
	rollbackLIST <- rollback(TheTree)
	
	num.col <- dim(x)[2]
	num.lin <- dim(x)[1]
	
	levelnode <- array(,0)
	paispos <- array(,0)
	nnode <- array(,0)
	namenode <- array(,0)
	probnode <- array(,0)
	utilitynode <- array(,0)
	effectivenessnode <- array(,0)
	typenode <- array(,0)
	paisnodos.n <- array(,0)
	paisnodos.name <- array(,0)
	paisnodos <- array(,0)
	expectedvalue.cost <- array(,0)
	expectedvalue.effectiveness <- array(,0)
	expectedvalue.ce <- array(,0)	
	
	for (i in 1:num.col) {
		max.node <- max(x[,i], na.rm = TRUE)
		pais <- 1:max.node	
		for (k in pais) {
			levelnode <- c(levelnode,i)
			nodepos <- which(x[,i] == k)[1]
			paispos <- c(paispos, nodepos)
			if (i == 1) {
				paisnodos.n <- c(paisnodos.n, 1)
				paisnodos.name <- c(paisnodos.name, " ")
			} else {
				paisnodos.n <- c(paisnodos.n, x[nodepos, i-1])
				paisnodos.name <- c(paisnodos.name, y[nodepos, i-1])
			}
			nnode <- c(nnode, k)
			namenode <- c(namenode, y[nodepos, i])
			probnode <- c(probnode, probMAT[nodepos, i])
			utilitynode <- c(utilitynode, utilityMAT[nodepos, i])
			effectivenessnode <- c(effectivenessnode, effectivenessMAT[nodepos, i])
			typenode <- c(typenode, typeMAT[nodepos, i])
			expectedvalue.cost <- c(expectedvalue.cost, rollbackLIST[["Cost"]][nodepos, i])
			expectedvalue.effectiveness <- c(expectedvalue.effectiveness, rollbackLIST[["Effectiveness"]][nodepos, i])
			expectedvalue.ce <- c(expectedvalue.ce, rollbackLIST[["CE"]][nodepos, i])
			
		}
	}
	
	tabela <- data.frame(Level = levelnode, Node.N = nnode, Node.name = namenode,
						 "Mean Cost" = expectedvalue.cost,
						 "Mean Effectiveness" = expectedvalue.effectiveness,
						 "Mean C-E ratio" = expectedvalue.ce,
# 						 Father = paisnodos.n, 
						 Father.Name = paisnodos.name,
						 Prob = probnode, Cost = utilitynode, Effectiveness = effectivenessnode,
						 Type = typenode						 
						 )

	return(tabela)
}

